﻿using Infragistics.Win;
using Infragistics.Win.UltraWinEditors;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace UltraComboEditorNoItemsTest
{
    public partial class Form1 : Form
    {
        DataTable gridTable;
        public Form1()
        {
            InitializeComponent();
            CreateTableAndBindToGrid();
            SetEntityIDToUltraCombo();
            ultraGrid1.Error += UltraGrid1_Error;
        }

        private void UltraGrid1_Error(object sender, Infragistics.Win.UltraWinGrid.ErrorEventArgs e)
        {
            var x = e.ErrorText;           
        }

        private void CreateTableAndBindToGrid()
        {
            gridTable = new DataTable();
            gridTable.Columns.Add("EntityID", typeof(int));
            gridTable.Columns.Add("Description", typeof(String));
            this.gridTable.Rows.Add(new object[] { 1, "Paul" });
            this.gridTable.Rows.Add(new object[] { 2, "John" });
            this.gridTable.Rows.Add(new object[] { 3, "Heidi" });
            this.ultraGrid1.SetDataBinding(this.gridTable, "", true);
        }

        private void SetEntityIDToUltraCombo()
        {
            this.ultraGrid1.DisplayLayout.Bands[0].Columns["EntityID"].EditorComponent = GetUltraComboEditor();
            this.ultraGrid1.DisplayLayout.Bands[0].Columns["EntityID"].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.DropDownValidate;
        }

        private UltraComboEditor GetUltraComboEditor()
        {
            DataTable comboTable = new DataTable();
            comboTable.Columns.Add("ID", typeof(int));
            comboTable.Columns.Add("EntityName", typeof(String));
            comboTable.Rows.Add(new object[] { 1, "Paul" });
            comboTable.Rows.Add(new object[] { 2, "John" });
            comboTable.Rows.Add(new object[] { 3, "Heidi" });

            UltraComboEditor editor = new UltraComboEditor();
            editor.BindingContext = this.BindingContext;
            editor.DataSource = comboTable;
            editor.ValueMember = "ID";
            editor.AlwaysInEditMode = true;
            editor.DisplayMember = "EntityName";
            editor.DropDownStyle = Infragistics.Win.DropDownStyle.DropDown;
            editor.ItemNotInList += Editor_ItemNotInList;

            editor.LimitToList = true;            

            return editor;
        }

        //Will never fire because it's in an UltraGrid.
        private void Editor_ItemNotInList(object sender, ValidationErrorEventArgs e)
        {
            throw new NotImplementedException();
        }
    }
}
